/*
 * temperature.h
 *
 *  Created on: 22.04.2016
 *      Author: pavel
 */

#ifndef TEMPERATURE_H_
#define TEMPERATURE_H_

#include <stdbool.h>
#include "onewire.h"


typedef struct
{
  float   Temperature;  // Значение температуры
  uint8_t ErrorCounter; // Счетчик ошибок связи с датчиком
  uint8_t ErrorCycle;   // Счетчик ошибок циклов преобразования температуры
  uint8_t SensorState;  // Состояние датчика (0 - датчик работает, 1 - неисправность)
} TEMPERATURE_SENSORS_t;

/**
  * @brief Cтруктура датчиков температуры (измерения, состояния, счетчики ошибок)
  */
TEMPERATURE_SENSORS_t sTemperSensors[MAX_T_SENSORS];

/**
  * @brief Флаг инициализации данных температурных датчиков
  */
bool fTemperDataReady;

/**
  * @brief  Инициализация датчиков температуры 1-wire
  */
void OW_Init(void);

#endif /* TEMPERATURE_H_ */
